/* Terraform - (C) 1997-2000 Robert Gasch (r.gasch@chello.nl)
 *  - http://terraform.sourceforge.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <glib.h>
#include "tterrain.h"

void t_terrain_fill           (TTerrain *terrain,
                               gfloat    elevation,
                               gfloat    factor);
void t_terrain_fold           (TTerrain *terrain,
                               gint      margin);
void t_terrain_radial_scale   (TTerrain *terrain,
                               gfloat    center_x, 
                               gfloat    center_y, 
                               gfloat    scale_factor, 
                               gfloat    min_dist,
                               gfloat    max_dist, 
                               gfloat    smooth_factor);
void t_terrain_gaussian_hill  (TTerrain *terrain,
                               gfloat    center_x,
                               gfloat    center_y,
                               gfloat    radius,
                               gfloat    radius_factor,
                               gfloat    hscale,
                               gfloat    smooth_factor,
                               gfloat    delta_scale);
void t_terrain_mirror         (TTerrain *terrain,
                               gint      type);
void t_terrain_craters        (TTerrain *terrain,
                               gint      count,
                               gboolean  wrap,
                               gfloat    height_scale,
                               gfloat    radius_scale,
                               gfloat    crater_coverage,
                               gint      seed,
                               gfloat    center_x,
                               gfloat    center_y);
void t_terrain_rotate         (TTerrain *terrain,
                               gint      amount);
void t_terrain_roughen_smooth (TTerrain *terrain,
                               gboolean  roughen,
                               gboolean  big_grid,
                               gfloat    factor);
void t_terrain_terrace        (TTerrain *terrain,
                               gint      level_count,
                               gfloat    factor,
                               gboolean  adjust_sealevel);
void t_terrain_draw_transform (TRgb     *rgb,
                               gfloat    sea_threshold,
                               gfloat    sea_depth,
                               gfloat    sea_dropoff,
                               gfloat    above_power,
                               gfloat    below_power);
void t_terrain_transform      (TTerrain *terrain,
                               gfloat    sea_threshold,
                               gfloat    sea_depth,
                               gfloat    sea_dropoff,
                               gfloat    above_power,
                               gfloat    below_power);
void t_terrain_tiler          (TTerrain *terrain,
                               gfloat    offset);
void t_terrain_tile           (TTerrain *terrain,
                               gint      multiply);
TTerrain *t_terrain_flowmap   (TTerrain *terrain,
                               gboolean  do_sfd,
                               gboolean  ignore_sealevel,
                               gfloat    max_elevation_erode);
gint t_terrain_erode          (TTerrain *terrain,
                               gint      turn_count,
                               gint      max_flow_age,
                               gfloat    max_elevation_erode,
                               gchar    *filename,
                               gint      frame_count,
                               gboolean  trim_local_peaks,
                               gboolean  do_sfd,
                               gboolean  ignore_sealevel,
                               TRgb     *rgb);
TTerrain *t_terrain_merge     (TTerrain *terrain_1,
                               TTerrain *terrain_2,
                               gfloat    weight_1,
                               gfloat    weight_2,
                               gint      operation);
void t_terrain_half           (TTerrain *terrain);
void t_terrain_double         (TTerrain *terrain,
                               gfloat    local,
                               gfloat    global);
void t_terrain_move           (TTerrain *terrain,
                               gfloat    x_offset,
                               gfloat    y_offset);
void t_terrain_connect        (TTerrain *terrain,
                               gint      iteration_count);
