/* Terraform - (C) 1997-2000 Robert Gasch (r.gasch@chello.nl)
 *  - http://terraform.sourceforge.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <time.h>
#include <stdlib.h>
#include "genperlin.h"
#include "gensubdiv.h"
#include "genspectral.h"
#include "genrandom.h"

TTerrain *
t_terrain_generate_random ()
{
  gint     i;
  gint     r, size;
  gboolean enabled[4];
  gint     octaves[4];
  gfloat   frequency[4];
  gfloat   amplitude[4];
  gint     filter[4];

  size = 400;

  srand (time (NULL));
  r = rand () % 1000;

  if (r > 250)
    return t_terrain_generate_subdiv (rand () % 6, size, 0.5, -1);
  else if (r < 125)
    return t_terrain_generate_spectral (size, 0.5, -1, FALSE);

  for (i = 0; i < 4; i++)
    {
      enabled[i] = rand() & 1;
      frequency[i] = (rand() % 100) / 100 + 0.017;
      amplitude[i] = (rand() % 4096) + 4096;
      octaves[i] = (rand() % 10) + 1;
      filter[i] = rand() % 23;
    }

  enabled[0] = TRUE;

  return t_terrain_generate_perlin (size, size, -1, enabled, frequency,
                                    amplitude, octaves, filter);
}
